////////////////////////////////////////////////////////////////////////
//
//        File  Name : member.cc
//        Class Name : members
//        Author     : Young-ki Hwang
//        Date       : April 30, 1996
//        Description: This is the methods of  "members" class.
//       
//       
///////////////////////////////////////////////////////////////////////


#include "member.h"



//
// constructor: members()
// Set up that no one is participating yet.
//
members::members()
{
  top = 0;
}


//
//  insert()
//  Insert a new member into the table. If it succeed return 1, otherwise
//  return 0.
//
int members::insert(server& server1, pipes& pipe1, pipes& pipe2, char *nickname)
{  int i, socketfd, p_read, p_write;
   char buf1[128] ="######  ";
   char buf2[15];
   char buf3[] =" has joined !!!  =======================>";

  
  socketfd = server1.get_newsockfd(); // socket descriptor of the member
  p_read = pipe2.get_readpipe();      // pipe for read of the member
  p_write = pipe1.get_writepipe();    // pipe for write of the member


  // Check if somebody is using a same id. 
  // If yes, send a message about that.
  if(check_exist(nickname))
    { while(!server1.send(socketfd, "ID is alreday exist, pleas use another one !!!"));
      return(0);
    }

   // If no, send a "ok" message.
   while(!server1.send(socketfd, "ok"));


   // Insert a new member into the table.
   table[top].socketfd = socketfd;
   string.copy(table[top].nickname, nickname);
   table[top].readpipe = p_read;
   table[top].writepipe = p_write;
   top++;
 
 
   string.copy(buf2, nickname);
   string.concatenate(buf1, buf2);
   string.concatenate(buf1, buf3);

   // Notify to everybody that new member is joined.
   for(i=0; i<top; i++)
      while(!server1.send(table[i].socketfd, buf1));

   return(1);
}



//
//  remove()
//  Delete a member from the table.
//
members::remove(server& server1, char *nickname)
{  int i;
   char buf1[128] ="######  ";
   char buf2[15];
   char buf3[] = " has left !!!  ========================>";


   // Find the member who are leaving.
   for(i=0; i<top; i++)
     { if(string.compare(table[i].nickname, nickname))
         break;
     }/* end for */

   // Delete the member from the table.
   for( ; i<top; i++)
     { table[i].socketfd = table[i+1].socketfd;
       string.copy(table[i].nickname, table[i+1].nickname);
       table[i].readpipe = table[i+1].readpipe;
       table[i].writepipe = table[i+1].writepipe;
     }/* end for */
 
   top--;

   string.copy(buf2, nickname);
   string.concatenate(buf1, buf2);
   string.concatenate(buf1, buf3);

   // Notify to everybody that the member is leaving.
   for(i=0; i<top; i++)
      while(!server1.send(table[i].socketfd, buf1));
}


 
//
//  change_nickname()
//  Change a nickename.
//
members::change_nickname(server& server1, int index, char *new_nickname)
{  int i;
   char buf1[128] ="######  ";
   char buf2[15];
   char buf3[] = " has changed the id to ";
   char buf4[] = " #######  ";


   string.copy(buf2, table[index].nickname);
   string.concatenate(buf1, buf2);
   string.concatenate(buf1, buf3);
   string.concatenate(buf1, new_nickname);
   string.concatenate(buf1, buf4);
   

   // Notify to everybody that the member has changed his nickkname.
   for(i=0; i<top; i++)
      while(!server1.send(table[i].socketfd, buf1));
 

  // Change the member's nickname.
   string.copy(table[index].nickname, new_nickname);

}



//
//  get_numofmember()
//  Get the number of members who are participating.
//
int members::get_numofmember()
{
   return(top);
}


//
//  get_nickname()
//  Get the nickname of the member who are participating.
//
members::get_nickname(int index, char *nickname)
{
   string.copy(nickname, table[index].nickname);
}


//
//  get_sockfd()
//  Get a socket file descriptor which the member is using from the table.
//
int members::get_sockfd(char *nickname)
{  int i;

   for(i=0; i<top; i++)
     { if(string.compare(table[i].nickname, nickname))
         return(table[i].socketfd);
     }/* end for */
}


//
//  get_sockfd()
//  Get a socket file descriptor by the index from the table.
//
int members::get_sockfd(int index)
{
   return(table[index].socketfd);
 }


//
//  get_readpipe()
//  Get a pipe descriptor by the index from the table.
//
int members::get_readpipe(int index)
{
   return(table[index].readpipe);
 }


//
//  get_readpipe()
//  Get a pipe descriptor by the index from the table.
//
int members::get_writepipe(int index)
{
   return(table[index].writepipe);
 }


//
//  check_exist()
//  Check if id is alreday exist.
//
int members::check_exist(char *nickname)
{   int i;

    for(i=0; i<top; i++)
     { if(string.compare(table[i].nickname, nickname))
         return(1);
     }/* end for */
 
    return(0);
}













